%define major 3
%define libname %mklibname gd %{major}
%define develname %mklibname gd -d
%define staticdevelname %mklibname gd -d -s

Summary:	A library used to create PNG, JPEG, or WBMP images
Name:		libgd
Version:	2.2.2
%define subrel	1
Release:	%mkrel 1
License:	BSD-like
Group:		System/Libraries
URL:		http://www.libgd.org/
Source0:	https://github.com/libgd/libgd/releases/download/gd-%{version}/%{name}-%{version}.tar.xz
Source1:	php_bug_72339_exp.gd2
Patch0:		libgd-2.2.2-CVE-2016-6128.patch
Patch1:		libgd-2.2.2-CVE-2016-5766.patch
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2) >= 9.8.3
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	libjpeg-devel
BuildRequires:	zlib-devel

%description
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

%package -n	%{libname}
Summary:	A library used to create PNG, JPEG, or WBMP images
Group:		System/Libraries
Provides:	gd = %{version}-%{release}
Obsoletes:	gd

%description -n	%{libname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains the library needed to run programs dynamically linked
with libgd.

%package -n	%{develname}
Summary:	The development libraries and header files for gd
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	gd-devel = %{version}-%{release}
Obsoletes:	gd-devel
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

These are the development libraries and header files for gd, the .png and .jpeg
graphics library. If you're installing the gd graphics library, you'll probably
want to install gd-devel.

%package -n	%{staticdevelname}
Summary:	Static GD library
Group:		Development/C
Requires:	%{develname} = %{version}
Provides:	libgd-static-devel = %{version}-%{release}
Provides:	gd-static-devel = %{version}-%{release}

%description -n	%{staticdevelname}
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains static gd library.

%package -n	gd-utils
Summary:	The Utils files for gd
Group:		System/Libraries
Requires:	%{libname} = %{version}

%description -n	gd-utils
gd is a graphics library. It allows your code to quickly draw images complete
with lines, arcs, text, multiple colors, cut and paste from other images, and
flood fills, and write out the result as a PNG or JPEG file. This is
particularly useful in World Wide Webapplications, where PNG and JPEG are two
of the formats accepted for in-line images by most browsers.

gd is not a paint program. If you are looking for a paint program, you are
looking in the wrong place. If you are not a programmer, you are looking in the
wrong place. 

gd does not provide for every possible desirable graphics operation. It is not
necessary or desirable for gd to become a kitchen-sink graphics package, but
version 1.7.3 incorporates most of the commonly requested features for an 8-bit
2D package.

This package contains various utilities utilizing the gd library.

%prep

%setup -q -n libgd-%{version}
%autopatch -p1
cp %{SOURCE1} tests/gd2/

%build
autoreconf -fi
%configure2_5x
%make

%check
%ifarch %{ix86}
# see https://github.com/libgd/libgd/issues/242
export XFAIL_TESTS="gdimagerotate/bug00067 $XFAIL_TESTS"
%endif
 
make check

%install
%makeinstall_std

sed -i -e 's!-Wl,--as-needed!!' -e 's!-Wl,--no-undefined!!' %{buildroot}%{_bindir}/gdlib-config

%multiarch_binaries %{buildroot}%{_bindir}/gdlib-config
%multiarch_includes %{buildroot}%{_includedir}/gd.h

install -m 0644 src/gdhelpers.h %{buildroot}%{_includedir}/

rm -f %buildroot%{_libdir}/*.la

%files -n %{libname}
%doc docs/README.TXT src/COPYING
%{_libdir}/*.so.%{major}
%{_libdir}/*.so.%{major}.*

%files -n %{develname}
%attr(644,root,root) %doc NEWS
%{_bindir}/gdlib-config
%multiarch %{multiarch_bindir}/gdlib-config
%{_libdir}/*.so
%{_libdir}/pkgconfig/gdlib.pc
%{_includedir}/*.h
%multiarch %{multiarch_includedir}/*.h

%files -n %{staticdevelname}
%{_libdir}/lib*.a

%files -n gd-utils
%{_bindir}/annotate
%{_bindir}/bdftogd
%{_bindir}/gd2copypal
%{_bindir}/gd2topng
%{_bindir}/gdparttopng
%{_bindir}/gdtopng
%{_bindir}/pngtogd
%{_bindir}/pngtogd2
%{_bindir}/webpng
%{_bindir}/gd2togif
%{_bindir}/gdcmpgif
%{_bindir}/giftogd2


%changelog
* Thu Jun 30 2016 luigiwalser <luigiwalser> 2.2.2-1.1.mga5
+ Revision: 1038202
- add upstream patch to fix CVE-2016-5766
- add binary test case for CVE-2016-5766 as Source1
- add upstream patch to fix CVE-2016-6128
- 2.2.2
- BR libwebp, not vpx, for webp support
- re-enable webp support (BR libvpx)
- 2.2.1
- add upstream patch to fix CVE-2015-8877
- add upstream patch to fix CVE-2015-8874
- add upstream patch to fix CVE-2016-3074

* Mon Feb 02 2015 oden <oden> 2.1.1-1.mga5
+ Revision: 813085
- 2.1.1

* Fri Jan 23 2015 luigiwalser <luigiwalser> 2.1.0-8.mga5
+ Revision: 812017
- add upstream changes to fix possible buffer read overflow (php#68601)

* Wed Oct 15 2014 umeabot <umeabot> 2.1.0-7.mga5
+ Revision: 742130
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.1.0-6.mga5
+ Revision: 681475
- Mageia 5 Mass Rebuild

* Thu Aug 21 2014 luigiwalser <luigiwalser> 2.1.0-5.mga5
+ Revision: 666100
- use libgd upstream CVE-2014-2497 patch

* Thu Jun 12 2014 luigiwalser <luigiwalser> 2.1.0-4.mga5
+ Revision: 635830
- add patch from PHP bug 66901 to fix CVE-2014-2497 (thx to opensuse for the ref)

* Sat Oct 19 2013 umeabot <umeabot> 2.1.0-3.mga4
+ Revision: 530325
- Mageia 4 Mass Rebuild

* Mon Jul 22 2013 oden <oden> 2.1.0-2.mga4
+ Revision: 457139
- sync with php-5.5.1

* Thu Jul 11 2013 oden <oden> 2.1.0-1.mga4
+ Revision: 452893
- 2.1.0

* Mon Jun 24 2013 oden <oden> 2.1.0-0.0.rc2.2.mga4
+ Revision: 446221
- P0: upstream fix for failing tests on 32bit arch (debian)
- 2.1.0-rc2

  + fwang <fwang>
    - add libtiff br

* Sun Jun 02 2013 fwang <fwang> 2.1.0-0.0.rc1.2.mga4
+ Revision: 434643
- rebuild for new libpng

* Sun May 26 2013 oden <oden> 2.1.0-0.0.rc1.1.mga4
+ Revision: 428141
- imported package libgd

